/* RCS $Id: j_acsh.c,v 1.2 1997/07/15 14:57:04 ae13 Exp $ */
/*
$Log: j_acsh.c,v $
 * Revision 1.2  1997/07/15  14:57:04  ae13
 * *** empty log message ***
 *
 * Revision 1.1  1997/05/16  13:26:20  ae13
 * Initial revision
 *
 */
/****************************************************************/
/*                                                              */
/*      Entries         : a_intv j_acsh(a_intv x)               */
/*                        a_intv x  ;                           */
/*                                                              */
/*      Arguments       : x = interval argument of acsh(x)      */
/*                                                              */
/*      Description     : Fast interval area cosine function    */
/*                        for double IEEE Floating-Point        */
/*                        Arithmetic                            */
/*                                                              */
/*      Date            : 1997-03-10                            */
/*                                                              */
/*      Author          : W. Hofschuster                        */
/*                                                              */
/****************************************************************/

#ifndef ALL_IN_ONE
#ifdef AIX
#include "/u/p88c/runtime/o_defs.h"
#else
#include "o_defs.h"
#endif
#define local
#endif

#include "q_defs.h"
#include "q_fcth.h"

#ifdef LINT_ARGS
local a_intv j_acsh(a_intv x)
#else
local a_intv j_acsh(x)

a_intv x;
#endif
{
  a_intv res;
  if (x.INF<1)                    /* Invalid argument */
  {
#ifdef PXSCTRAP      
      E_SPUSH("j_acsh");
#endif
      res=q_abortr2(INV_ARG,&x.INF,&x.SUP,23);
#ifdef PXSCTRAP
      E_SPOPP("j_acsh");
#endif
  } 
  else
  {
    if (x.INF==x.SUP)             /* point interval */
    { 
        if (x.INF==1) 
          res.INF=res.SUP=0;
        else
        { 
          res.INF=q_acsh(x.INF);
          res.SUP=res.INF*q_acsp;
          res.INF*=q_acsm;
        }
    }
    else
    {
      res.INF=q_acsh(x.INF)*q_acsm;
      res.SUP=q_acsh(x.SUP)*q_acsp;
    }   
  }
  return(res);
}

